## superlu-dist 5.4.0+dfsg1

=== CMakeLists.txt ===
######################################################################
#
# CMakeLists.txt for SUPERLU_DIST
#
######################################################################

# Required version
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

# Project version numbers
project(SuperLU_DIST C)
set(VERSION_MAJOR "5")
set(VERSION_MINOR "4")
set(VERSION_BugFix "0")
set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix})

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

# Set up options
option(enable_blaslib   "Build the CBLAS library" ${enable_blaslib_DEFAULT})
option(enable_doc       "Build doxygen documentation" OFF)
option(enable_double    "Enable double precision library" ON)
option(enable_complex16 "Enable complex16 precision library" ON)
option(enable_tests  "Build tests" ON)
option(enable_examples  "Build examples" ON)
option(enable_parmetislib   "Build the ParMETIS library" ON)
option(TPL_PARMETIS_LIBRARIES "List of absolute paths to ParMETIS link libraries [].")
option(TPL_PARMETIS_INCLUDE_DIRS "List of absolute paths to ParMETIS include directories [].")
option(enable_combblaslib   "Build the CombBLAS library" OFF)
option(TPL_COMBBLAS_LIBRARIES "List of absolute paths to CombBLAS link libraries [].")
option(TPL_COMBBLAS_INCLUDE_DIRS "List of absolute paths to CombBLAS include directories [].")

if (NOT enable_combblaslib)
  SET(XSDK_ENABLE_CXX OFF)
endif()

######################################################################
#
# IDEAS: xSDK standards module
MESSAGE("\nProcess XSDK defaults ...")
# SET(USE_XSDK_DEFAULTS_DEFAULT TRUE) # Set to false if desired
INCLUDE("cmake/XSDKDefaults.cmake")
INCLUDE(CTest)
######################################################################

######################################################################
#
# Usual initialization stuff
#
######################################################################
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)    ## ????
set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")

#---- For shared library

# use, i.e. don't skip the full RPATH for the build tree
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
#----

SET(BUILD_STATIC_LIBS TRUE CACHE BOOL "Include static libs when building shared")

if (BUILD_SHARED_LIBS)
  message("-- SuperLU_DIST will be built as a shared library.")
  set(PROJECT_NAME_LIB_EXPORT libsuperlu_dist.so)
  if (BUILD_STATIC_LIBS)
    message("-- SuperLU_DIST will also be built as a static library.")
  endif()
else()
  message("-- SuperLU_DIST will be built as a static library.")
  set(PROJECT_NAME_LIB_EXPORT libsuperlu_dist.a)
endif()

if (XSDK_ENABLE_CXX)
  enable_language (CXX)
  set(NOCXX FALSE)
endif()
if (XSDK_ENABLE_Fortran)
  enable_language (Fortran)
  set(NOFORTRAN FALSE)
endif()
set(SUPERLU_VERSION "${PROJECT_VERSION}")
set(SUPERLU_REV "${PROJECT_REV}")

# The XSDK standard does not allow using internally built BLAS
if (USE_XSDK_DEFAULTS)
  set(enable_blaslib_DEFAULT OFF)
else()
  set(enable_blaslib_DEFAULT ON)
endif()

if (NOT CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX /usr/local)
endif()


if(NOT MSVC)
  include(GNUInstallDirs)
  set(default_install_inc_dir ${CMAKE_INSTALL_INCLUDEDIR})
  set(default_install_lib_dir ${CMAKE_INSTALL_LIBDIR})
  set(default_install_bin_dir ${CMAKE_INSTALL_BINDIR})
else()
  set(default_install_inc_dir "include")
  set(default_install_lib_dir "lib")
  set(default_install_bin_dir "bin")
endif()

set(INSTALL_INC_DIR "${default_install_inc_dir}" CACHE STRING "The folder where headers will be installed.")
set(INSTALL_LIB_DIR "${default_install_lib_dir}" CACHE STRING "The folder where libraries will be installed.")
set(INSTALL_BIN_DIR "${default_install_bin_dir}" CACHE STRING "The folder where runtime files will be installed.")


# Set up required compiler defines and options.
## get_directory_property( DirDefs COMPILE_DEFINITIONS )
# set(CMAKE_C_FLAGS "-DDEBUGlevel=0 -DPRNTlevel=0 ${CMAKE_C_FLAGS}")
if(XSDK_INDEX_SIZE EQUAL 64)
    message("-- Using 64 bit integer for index size")
endif()	
set(CMAKE_C_FLAGS_RELEASE "-O3" CACHE STRING "")
set(CMAKE_CXX_FLAGS_RELEASE "-O3" CACHE STRING "")

######################################################################
#
# Find packages
#
######################################################################
#
#--------------------- MPI ---------------------
find_package(MPI)
if(MPI_C_FOUND)
    set(CMAKE_C_FLAGS "${MPI_C_COMPILE_FLAGS} ${CMAKE_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${MPI_CXX_COMPILE_FLAGS} ${CMAKE_CXX_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${MPI_C_LINK_FLAGS}" )
endif()
#--------------------- OpenMP ---------------------
if (NOT DEFINED enable_openmp)
  set(enable_openmp TRUE)
endif ()
if (enable_openmp)
  find_package(OpenMP)
## include(FindOpenMP)  # Strumpack uses this
  if(OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${OpenMP_C_FLAGS} ${CMAKE_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
# On edison, OpenMP_EXE_LINKER_FLAGS is empty
#  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_C_FLAGS}")
    message("-- OpenMP_EXE_LINKER_FLAGS='${OpenMP_EXE_LINKER_FLAGS}'")
    message("-- CMAKE_EXE_LINKER_FLAGS='${CMAKE_EXE_LINKER_FLAGS}'")
  endif()
endif()
#--------------------- BLAS ---------------------
if(NOT enable_blaslib)
#  set(TPL_BLAS_LIBRARIES "" CACHE FILEPATH
#    "Override of list of absolute path to libs for BLAS.")
  if(TPL_BLAS_LIBRARIES)
    set(BLAS_FOUND TRUE)
  else()
    find_package(BLAS)
    if(BLAS_FOUND)
      set(TPL_BLAS_LIBRARIES "${BLAS_LIBRARIES}" CACHE FILEPATH
        "Set from FindBLAS.cmake BLAS_LIBRARIES." FORCE)
    endif()
  endif()
endif()

if(BLAS_FOUND)
    message("-- Using TPL_BLAS_LIBRARIES='${TPL_BLAS_LIBRARIES}'")
    set(CMAKE_C_FLAGS "-DUSE_VENDOR_BLAS ${CMAKE_C_FLAGS}")
    set(BLAS_LIB ${TPL_BLAS_LIBRARIES})
    # fix up BLAS library name
    string (REPLACE ";" " " BLAS_LIB_STR "${BLAS_LIB}")
    set(BLAS_LIB_EXPORT ${BLAS_LIB_STR})
else()
    message("-- Did not find or specify BLAS, so configure to build internal CBLAS ...")
    add_subdirectory(CBLAS)
    set(BLAS_LIB blas)
    if (BUILD_SHARED_LIBS)  # export to be referenced by downstream makefile
        set(BLAS_LIB_EXPORT ${CMAKE_INSTALL_PREFIX}/CBLAS/libblas.so)
    else()
        set(BLAS_LIB_EXPORT ${CMAKE_INSTALL_PREFIX}/CBLAS/libblas.a)
    endif()
endif()

#--------------------- ParMETIS ---------------------
if (enable_parmetislib)   ## want to use parmetis
  if (NOT TPL_PARMETIS_LIBRARIES)
    message(FATAL_ERROR "TPL_PARMETIS_LIBRARIES option should be set for PARMETIS support to be enabled.")
  endif()

  if (NOT TPL_PARMETIS_INCLUDE_DIRS)
    message(FATAL_ERROR "TPL_PARMETIS_INCLUDE_DIRS option be set for PARMETIS support to be enabled.")
  endif()
  foreach(dir ${TPL_PARMETIS_INCLUDE_DIRS})
    if (NOT EXISTS ${dir})
      message(FATAL_ERROR "PARMETIS include directory not found: ${dir}")
    endif()
    set(CMAKE_C_FLAGS "-I${dir} ${CMAKE_C_FLAGS}")
  endforeach()

  message("-- Enabled support for PARMETIS")
  set(PARMETIS_FOUND TRUE)

  set(PARMETIS_LIB ${TPL_PARMETIS_LIBRARIES})
  # fix up PARMETIS library names
  string (REPLACE ";" " " PARMETIS_LIB_STR "${PARMETIS_LIB}")
  set(PARMETIS_LIB_EXPORT ${PARMETIS_LIB_STR})

else()
  message("-- Will not link with ParMETIS.")
endif()

if(enable_parmetislib AND NOT PARMETIS_FOUND)
  find_package(ParMETIS)
  if(PARMETIS_FOUND)
    set(PARMETIS_LIB ParMETIS::ParMETIS)
    set(TPL_PARMETIS_INCLUDE_DIRS "")
  endif()
endif()

if(PARMETIS_FOUND)
  set(HAVE_PARMETIS TRUE)
endif()

#--------------------- CombBLAS ---------------------
if (enable_combblaslib)   ## want to use CombBLAS
  if (NOT TPL_COMBBLAS_LIBRARIES)
    message(FATAL_ERROR "TPL_COMBBLAS_LIBRARIES option should be set for COMBBLAS support to be enabled.")
  endif()

  if (NOT TPL_COMBBLAS_INCLUDE_DIRS)
    message(FATAL_ERROR "TPL_COMBBLAS_INCLUDE_DIRS option be set for COMBBLAS support to be enabled.")
  endif()
  foreach(dir ${TPL_COMBBLAS_INCLUDE_DIRS})
    if (NOT EXISTS ${dir})
      message(FATAL_ERROR "COMBBLAS include directory not found: ${dir}")
    endif()
    set(CMAKE_CXX_FLAGS "-I${dir} ${CMAKE_CXX_FLAGS}")
  endforeach()

  message("-- Enabled support for COMBBLAS")
  set(COMBBLAS_FOUND TRUE)

  set(COMBBLAS_LIB ${TPL_COMBBLAS_LIBRARIES})
  # fix up COMBBLAS library names
  string (REPLACE ";" " " COMBBLAS_LIB_STR "${COMBBLAS_LIB}")
  set(COMBBLAS_LIB_EXPORT ${COMBBLAS_LIB_STR})

else()
  message("-- Will not link with CombBLAS.")
endif()

if(COMBBLAS_FOUND)
  set(HAVE_COMBBLAS TRUE)
  set(LOADER $(CXX))
else()
  set(LOADER $(CC))
endif()


######################################################################
#
# Include directories
#
######################################################################

include_directories(${CMAKE_BINARY_DIR}/SRC) # For superlu_dist_config.h
# include_directories(${CMAKE_SOURCE_DIR}/SRC)
if (TPL_PARMETIS_INCLUDE_DIRS)
  include_directories(${TPL_PARMETIS_INCLUDE_DIRS})  ## parmetis
endif ()
if (TPL_COMBBLAS_INCLUDE_DIRS)
  include_directories(${TPL_COMBBLAS_INCLUDE_DIRS})  ## CombBLAS
endif ()
include_directories(${MPI_C_INCLUDE_PATH})

######################################################################
#
# Add subdirectories
#
######################################################################

add_subdirectory(SRC)

if(enable_doc)
  message(FATAL_ERROR "Documentation build requested but not implemented.")
  #implement doxygen
endif()

if(enable_tests)
  enable_testing()
  add_subdirectory(TEST)
endif()

if(enable_examples)
  enable_testing()
  add_subdirectory(EXAMPLE)
endif()

# configure_file(${CMAKE_SOURCE_DIR}/make.inc.in ${CMAKE_BINARY_DIR}/make.inc)
configure_file(${SuperLU_DIST_SOURCE_DIR}/make.inc.in ${SuperLU_DIST_SOURCE_DIR}/make.inc)
configure_file(${SuperLU_DIST_SOURCE_DIR}/SRC/superlu_dist_config.h.in ${SuperLU_DIST_BINARY_DIR}/SRC/superlu_dist_config.h)
configure_file(${SuperLU_DIST_SOURCE_DIR}/SRC/superlu_dist_config.h.in ${SuperLU_DIST_SOURCE_DIR}/SRC/superlu_dist_config.h)

# Add pkg-config support
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/superlu_dist.pc.in ${CMAKE_CURRENT_BINARY_DIR}/superlu_dist.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/superlu_dist.pc
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== SRC/Makefile ===
#######################################################################
#
#  This makefile creates a library for distributed SuperLU.
#  The files are organized as follows:
#
#       ALLAUX  -- Auxiliary routines called from all precisions
#       DSLUSRC -- Double precision real serial SuperLU routines
#       DPLUSRC -- Double precision real parallel SuperLU routines
#       ZSLUSRC -- Double precision complex serial SuperLU routines
#       ZPLUSRC -- Double precision complex parallel SuperLU routines
#
#  The library can be set up to include routines for any combination
#  of the two precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make double
#       make double complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all two precisions.
#  The library is called
#       superlu.a
#  and is created at the next higher directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#
#######################################################################
include ../make.inc
#
# Precision independent routines
#
ALLAUX 	= sp_ienv.o etree.o sp_colorder.o get_perm_c.o \
	  colamd.o mmd.o comm.o memory.o util.o superlu_grid.o \
	  pxerr_dist.o superlu_timer.o symbfact.o \
	  psymbfact.o psymbfact_util.o get_perm_c_parmetis.o mc64ad_dist.o \
	  static_schedule.o xerr_dist.o smach_dist.o dmach_dist.o \
	  superlu_dist_version.o

ifeq "${ACC}" "GPU"
ALLAUX += cublas_utils.o
endif

ifeq ($(HAVE_COMBBLAS),TRUE)
ALLAUX += c2cpp_GetAWPM.o
endif

#
# Routines literally taken from SuperLU, but renamed with suffix _dist
#
DSLUSRC	= dlangs_dist.o dgsequ_dist.o dlaqgs_dist.o dutil_dist.o \
	  dmemory_dist.o dmyblas2_dist.o dsp_blas2_dist.o dsp_blas3_dist.o
ZSLUSRC	= dcomplex_dist.o zlangs_dist.o zgsequ_dist.o zlaqgs_dist.o \
	  zutil_dist.o zmemory_dist.o zmyblas2_dist.o \
	  zsp_blas2_dist.o zsp_blas3_dist.o

#
# Routines for double precision parallel SuperLU
DPLUSRC = pdgssvx.o pdgssvx_ABglobal.o \
	  dreadhb.o dreadrb.o dreadtriple.o dreadMM.o \
	  pdgsequ.o pdlaqgs.o dldperm_dist.o pdlangs.o pdutil.o \
	  pdsymbfact_distdata.o ddistribute.o pddistribute.o \
	  pdgstrf.o pdgstrf2.o pdGetDiagU.o \
	  pdgstrs.o pdgstrs1.o pdgstrs_lsum.o pdgstrs_Bglobal.o \
	  pdgsrfs.o pdgsmv.o pdgsrfs_ABXglobal.o pdgsmv_AXglobal.o 

#
# Routines for double complex parallel SuperLU
ZPLUSRC = pzgssvx.o pzgssvx_ABglobal.o \
	  zreadhb.o zreadrb.o zreadtriple.o zreadMM.o \
	  pzgsequ.o pzlaqgs.o zldperm_dist.o pzlangs.o pzutil.o \
	  pzsymbfact_distdata.o zdistribute.o pzdistribute.o \
	  pzgstrf.o pzgstrf2.o pzGetDiagU.o \
	  pzgstrs.o pzgstrs1.o pzgstrs_lsum.o pzgstrs_Bglobal.o \
	  pzgsrfs.o pzgsmv.o pzgsrfs_ABXglobal.o pzgsmv_AXglobal.o 

all:  double complex16

config_h:
	rm -f superlu_dist_config.h
ifeq ($(XSDK_INDEX_SIZE),64)
		printf "#define XSDK_INDEX_SIZE 64\n" >> superlu_dist_config.h
else
		printf "/* #define XSDK_INDEX_SIZE 64 */\n" >> superlu_dist_config.h
endif
ifeq ($(HAVE_PARMETIS),TRUE)
		printf "#define HAVE_PARMETIS TRUE\n" >> superlu_dist_config.h
else
		printf "/* #define HAVE_PARMETIS TRUE */\n" >> superlu_dist_config.h
endif
ifeq ($(HAVE_COMBBLAS),TRUE)
		printf "#define HAVE_COMBBLAS TRUE\n" >> superlu_dist_config.h
else
		printf "/* #define HAVE_COMBBLAS TRUE */\n" >> superlu_dist_config.h
endif
	printf "#if (XSDK_INDEX_SIZE == 64)\n#define _LONGINT 1\n#endif\n" >> superlu_dist_config.h


#config_h:
#	cp -f superlu_dist_config_for_makefile.h superlu_dist_config.h

double: config_h $(DSLUSRC) $(DPLUSRC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) $(DSUPERLULIB) \
		$(DSLUSRC) $(DPLUSRC) $(ALLAUX)
	$(RANLIB) $(DSUPERLULIB)

complex16: config_h $(ZSLUSRC) $(ZPLUSRC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) $(DSUPERLULIB) \
		$(ZSLUSRC) $(ZPLUSRC) $(ALLAUX)
	$(RANLIB) $(DSUPERLULIB)

pdgstrf.o: dscatter.c dlook_ahead_update.c dSchCompUdt-2Ddynamic.c pdgstrf.c
	$(CC) $(CFLAGS) $(CDEFS) $(BLASDEF) -I$(INCLUDEDIR) -c pdgstrf.c $(VERBOSE)

pzgstrf.o: zscatter.c zlook_ahead_update.c zSchCompUdt-2Ddynamic.c pzgstrf.c
	$(CC) $(CFLAGS) $(CDEFS) $(BLASDEF) -I$(INCLUDEDIR) -c pzgstrf.c $(VERBOSE)

c2cpp_GetAWPM.o: c2cpp_GetAWPM.cpp
	$(CXX) $(CXXFLAGS) -I$(INCLUDEDIR) -o $@ -c $<

.c.o:
	$(CC) $(CFLAGS) $(CDEFS) $(BLASDEF) -I$(INCLUDEDIR) -c $< $(VERBOSE)

.f.o:
	$(FORTRAN) $(FFLAGS) -c $< $(VERBOSE)

clean:	
	rm -f *.o $(DSUPERLULIB) superlu_dist_config.h

=== debian/changelog ===
superlu-dist (5.4.0+dfsg1-1) unstable; urgency=medium

  * New upstream version.
    - provides LargeDiag_AWPM as an alternative row permutation
      LargeDiag to LargeDiag_MC64
  * Standards-Version: 4.2.1

 -- Drew Parsons <dparsons@debian.org>  Mon, 01 Oct 2018 11:58:33 +0800

=== debian/control ===
Source: superlu-dist
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper (>= 11),
	cmake (>= 2.8.12),
	mpi-default-dev, mpi-default-bin,
	gfortran,
	libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
	libscotchparmetis-dev | libparmetis-dev,
	libscotchmetis-dev | libmetis-dev
Standards-Version: 4.2.1
Section: libs
Homepage: http://crd-legacy.lbl.gov/~xiaoye/SuperLU/#superlu_dist
Vcs-Git: https://salsa.debian.org/science-team/superlu-dist.git
Vcs-Browser: https://salsa.debian.org/science-team/superlu-dist

Package: libsuperlu-dist-dev
Section: libdevel
Architecture: any
Depends: libsuperlu-dist5 (= ${binary:Version}), ${misc:Depends}
Description: Highly distributed solution of sparse linear equations
 SuperLU is a general purpose library for the direct solution of large,
 sparse, nonsymmetric systems of linear equations. The library is
 written in C and is callable from either C or Fortran program. It uses
 MPI, OpenMP and CUDA to support various forms of parallelism. It
 supports both real and complex datatypes, both single and double
 precision, and 64-bit integer indexing. The library routines performs
 an LU decomposition with partial pivoting and triangular system solves
 through forward and back substitution. The LU factorization routines
 can handle non-square matrices but the triangular solves are performed
 only for square matrices. The matrix columns may be preordered (before
 factorization) either through library or user supplied routines. This
 preordering for sparsity is completely separate from the
 factorization. Working precision iterative refinement subroutines are
 provided for improved backward stability. Routines are also provided
 to equilibrate the system, estimate the condition number, calculate
 the relative backward error, and estimate error bounds for the refined
 solutions. 
 .
 SuperLU_DIST implements the algorithms for distributed memory,
 targetting highly parallel distributed memory hybrid systems. The
 numerical factorization routines are already implemented for hybrid
 systems with multiple GPUs. Further work will be needed to implement
 the other phases of the algorithms on the hybrid systems and to
 enhance strong scaling to extreme scale.
 .
 This package provides development files for building client 
 applications against superlu-dist.

Package: libsuperlu-dist5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Highly distributed solution of sparse linear equations
 SuperLU is a general purpose library for the direct solution of large,
 sparse, nonsymmetric systems of linear equations. The library is
 written in C and is callable from either C or Fortran program. It uses
 MPI, OpenMP and CUDA to support various forms of parallelism. It
 supports both real and complex datatypes, both single and double
 precision, and 64-bit integer indexing. The library routines performs
 an LU decomposition with partial pivoting and triangular system solves
 through forward and back substitution. The LU factorization routines
 can handle non-square matrices but the triangular solves are performed
 only for square matrices. The matrix columns may be preordered (before
 factorization) either through library or user supplied routines. This
 preordering for sparsity is completely separate from the
 factorization. Working precision iterative refinement subroutines are
 provided for improved backward stability. Routines are also provided
 to equilibrate the system, estimate the condition number, calculate
 the relative backward error, and estimate error bounds for the refined
 solutions. 
 .
 SuperLU_DIST implements the algorithms for distributed memory,
 targetting highly parallel distributed memory hybrid systems. The
 numerical factorization routines are already implemented for hybrid
 systems with multiple GPUs. Further work will be needed to implement
 the other phases of the algorithms on the hybrid systems and to
 enhance strong scaling to extreme scale. 
 .
 This package provides the superlu-dist shared library.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Allow test programs that use OpenMPI to run
export OMPI_MCA_plm_rsh_agent=/bin/false


%:
	dh $@ --buildsystem=cmake


# NOTE: the superlu-dist cmake scripts generate a configuration error:
#   CMake Error in SRC/CMakeLists.txt:
#    Found relative path while evaluating include directories of "superlu_dist":
#      "OFF"
# with error code 1, which causes the build to halt.
# But the configuration seems fine (GNUInstallDirs are used to define standard install dirs).
# For now, work around the error by ignoring it (append "|| /bin/true")
override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUILD_SHARED_LIBS=ON -DCMAKE_SKIP_RPATH=ON \
	    -DCMAKE_C_COMPILER=mpicc -DCMAKE_FORTRAN_COMPILER=mpifort \
	    -DCMAKE_INSTALL_INCLUDEDIR=include/superlu-dist \
	    -Denable_blaslib=OFF -DTPL_BLAS_LIBRARIES=/usr/lib/$(DEB_HOST_MULTIARCH)/libblas.so \
	    -Denable_parmetislib=ON \
	    -DTPL_PARMETIS_INCLUDE_DIRS="/usr/include/scotch;/usr/include/parmetis;/usr/include/metis" \
	    -DTPL_PARMETIS_LIBRARIES="/usr/lib/$(DEB_HOST_MULTIARCH)/libparmetis.so;/usr/lib/$(DEB_HOST_MULTIARCH)/libmetis.so" \
	  || /bin/true


# set LD_LIBRARY_PATH to test against the libsuperlu_dist.so just built
override_dh_auto_test:
	export LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/SRC:$${LD_LIBRARY_PATH}; \
	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH} dh_auto_test || /bin/true

## superlu-dist 6.0.0+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,31 +8,29 @@
 cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
 
 # Project version numbers
-project(SuperLU_DIST C)
-set(VERSION_MAJOR "5")
-set(VERSION_MINOR "4")
+project(SuperLU_DIST C CXX)
+set(VERSION_MAJOR "6")
+set(VERSION_MINOR "0")
 set(VERSION_BugFix "0")
 set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix})
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
 
 # Set up options
-option(enable_blaslib   "Build the CBLAS library" ${enable_blaslib_DEFAULT})
 option(enable_doc       "Build doxygen documentation" OFF)
 option(enable_double    "Enable double precision library" ON)
 option(enable_complex16 "Enable complex16 precision library" ON)
 option(enable_tests  "Build tests" ON)
 option(enable_examples  "Build examples" ON)
-option(enable_parmetislib   "Build the ParMETIS library" ON)
+option(TPL_ENABLE_BLASLIB  "Build the CBLAS library" ${enable_blaslib_DEFAULT})
+option(TPL_ENABLE_PARMETISLIB   "Build the ParMETIS library" ON)
+option(TPL_ENABLE_LAPACKLIB "Enable LAPACK library" ON)
 option(TPL_PARMETIS_LIBRARIES "List of absolute paths to ParMETIS link libraries [].")
 option(TPL_PARMETIS_INCLUDE_DIRS "List of absolute paths to ParMETIS include directories [].")
-option(enable_combblaslib   "Build the CombBLAS library" OFF)
+option(TPL_ENABLE_COMBBLASLIB   "Build the CombBLAS library" OFF)
 option(TPL_COMBBLAS_LIBRARIES "List of absolute paths to CombBLAS link libraries [].")
 option(TPL_COMBBLAS_INCLUDE_DIRS "List of absolute paths to CombBLAS include directories [].")
 
-if (NOT enable_combblaslib)
-  SET(XSDK_ENABLE_CXX OFF)
-endif()
 
 ######################################################################
 #
@@ -81,10 +79,8 @@
   set(PROJECT_NAME_LIB_EXPORT libsuperlu_dist.a)
 endif()
 
-if (XSDK_ENABLE_CXX)
-  enable_language (CXX)
-  set(NOCXX FALSE)
-endif()
+set(CMAKE_CXX_STANDARD 11)
+
 if (XSDK_ENABLE_Fortran)
   enable_language (Fortran)
   set(NOFORTRAN FALSE)
@@ -119,12 +115,11 @@
 set(INSTALL_LIB_DIR "${default_install_lib_dir}" CACHE STRING "The folder where libraries will be installed.")
 set(INSTALL_BIN_DIR "${default_install_bin_dir}" CACHE STRING "The folder where runtime files will be installed.")
 
-
 # Set up required compiler defines and options.
 ## get_directory_property( DirDefs COMPILE_DEFINITIONS )
 # set(CMAKE_C_FLAGS "-DDEBUGlevel=0 -DPRNTlevel=0 ${CMAKE_C_FLAGS}")
 if(XSDK_INDEX_SIZE EQUAL 64)
-    message("-- Using 64 bit integer for index size")
+    message("-- Using 64 bit integer for index size.")
 endif()	
 set(CMAKE_C_FLAGS_RELEASE "-O3" CACHE STRING "")
 set(CMAKE_CXX_FLAGS_RELEASE "-O3" CACHE STRING "")
@@ -160,7 +155,7 @@
   endif()
 endif()
 #--------------------- BLAS ---------------------
-if(NOT enable_blaslib)
+if(NOT TPL_ENABLE_BLASLIB)
 #  set(TPL_BLAS_LIBRARIES "" CACHE FILEPATH
 #    "Override of list of absolute path to libs for BLAS.")
   if(TPL_BLAS_LIBRARIES)
@@ -192,8 +187,35 @@
     endif()
 endif()
 
+#--------------------- LAPACK ---------------------
+if(TPL_ENABLE_LAPACKLIB)  ## want to use LAPACK
+  if(TPL_LAPACK_LIBRARIES)
+    set(LAPACK_FOUND TRUE)
+  else()
+    find_package(LAPACK)
+    if(LAPACK_FOUND)
+      set(TPL_LAPACK_LIBRARIES "${LAPACK_LIBRARIES}" CACHE FILEPATH
+        "Set from FindLAPACK.cmake LAPACK_LIBRARIES." FORCE)
+    endif()
+  endif()
+else()  ## not to use LAPACK
+  set(LAPACK_FOUND FALSE)
+  set(HAVE_LAPACK FALSE)
+endif()
+
+if(LAPACK_FOUND)
+    message("-- Using TPL_LAPACK_LIBRARIES='${TPL_LAPACK_LIBRARIES}'")
+    set(LAPACK_LIB ${TPL_LAPACK_LIBRARIES})
+    # fix up LAPACK library name
+    string (REPLACE ";" " " LAPACK_LIB_STR "${LAPACK_LIB}")
+    set(LAPACK_LIB_EXPORT ${LAPACK_LIB_STR})
+    set(HAVE_LAPACK TRUE)
+else()
+    message("-- Will not link with LAPACK.")
+endif()
+
 #--------------------- ParMETIS ---------------------
-if (enable_parmetislib)   ## want to use parmetis
+if (TPL_ENABLE_PARMETISLIB)   ## want to use parmetis
   if (NOT TPL_PARMETIS_LIBRARIES)
     message(FATAL_ERROR "TPL_PARMETIS_LIBRARIES option should be set for PARMETIS support to be enabled.")
   endif()
@@ -208,19 +230,18 @@
     set(CMAKE_C_FLAGS "-I${dir} ${CMAKE_C_FLAGS}")
   endforeach()
 
-  message("-- Enabled support for PARMETIS")
+  message("-- Enabled support for PARMETIS.")
   set(PARMETIS_FOUND TRUE)
 
   set(PARMETIS_LIB ${TPL_PARMETIS_LIBRARIES})
   # fix up PARMETIS library names
   string (REPLACE ";" " " PARMETIS_LIB_STR "${PARMETIS_LIB}")
   set(PARMETIS_LIB_EXPORT ${PARMETIS_LIB_STR})
-
 else()
   message("-- Will not link with ParMETIS.")
 endif()
 
-if(enable_parmetislib AND NOT PARMETIS_FOUND)
+if(TPL_ENABLE_PARMETISLIB AND NOT PARMETIS_FOUND)
   find_package(ParMETIS)
   if(PARMETIS_FOUND)
     set(PARMETIS_LIB ParMETIS::ParMETIS)
@@ -233,7 +254,7 @@
 endif()
 
 #--------------------- CombBLAS ---------------------
-if (enable_combblaslib)   ## want to use CombBLAS
+if (TPL_ENABLE_COMBBLASLIB)   ## want to use CombBLAS
   if (NOT TPL_COMBBLAS_LIBRARIES)
     message(FATAL_ERROR "TPL_COMBBLAS_LIBRARIES option should be set for COMBBLAS support to be enabled.")
   endif()

=== SRC/CMakeLists.txt ===
set(headers
    Cnames.h
    cublas_utils.h
    dcomplex.h
    machines.h
    psymbfact.h
    superlu_defs.h
    superlu_enum_consts.h
    supermatrix.h
    util_dist.h
    colamd.h
    TreeBcast_slu.hpp
    TreeReduce_slu.hpp	
    TreeBcast_slu_impl.hpp
    TreeReduce_slu_impl.hpp	
    ${CMAKE_CURRENT_BINARY_DIR}/superlu_dist_config.h
)
if (MSVC)
  list(APPEND headers wingetopt.h)
endif ()

# first: precision-independent files
#  global.cpp
set(sources
  TreeInterface.cpp
  sp_ienv.c
  etree.c 
  sp_colorder.c
  get_perm_c.c
  mmd.c
  comm.c
  memory.c
  util.c
  superlu_grid.c
  pxerr_dist.c
  superlu_timer.c
  symbfact.c
  psymbfact.c
  psymbfact_util.c
  get_perm_c_parmetis.c
  mc64ad_dist.c
  static_schedule.c
  xerr_dist.c
  smach_dist.c
  dmach_dist.c
  colamd.c
  superlu_dist_version.c
)
if (MSVC)
  list(APPEND sources wingetopt.c)
endif ()

if (HAVE_COMBBLAS)
  list(APPEND sources c2cpp_GetAWPM.cpp AWPM_CombBLAS.hpp)
endif()

set_source_files_properties(superlu_timer.c PROPERTIES COMPILE_FLAGS -O0)

if(enable_double)
  list(APPEND headers superlu_ddefs.h)

  list(APPEND sources
    dlangs_dist.c
    dgsequ_dist.c
    dlaqgs_dist.c
    dutil_dist.c
    dmemory_dist.c
    dmyblas2_dist.c
    dsp_blas2_dist.c
    dsp_blas3_dist.c
    pdgssvx.c
    pdgssvx_ABglobal.c
    dreadhb.c
    dreadrb.c
    dreadtriple.c
    dbinary_io.c	
    dreadMM.c
    pdgsequ.c
    pdlaqgs.c
    dldperm_dist.c
    pdlangs.c
    pdutil.c
    pdsymbfact_distdata.c
    ddistribute.c
    pddistribute.c
    pdgstrf.c
    pdgstrf2.c
    pdgstrs.c
    pdgstrs1.c
    pdgstrs_lsum.c
    pdgstrs_Bglobal.c
    pdgsrfs.c
    pdgsmv.c
    pdgsrfs_ABXglobal.c
    pdgsmv_AXglobal.c
    pdGetDiagU.c
  )
endif()

if(enable_complex16)
  list(APPEND headers superlu_zdefs.h)

  list(APPEND sources
    dcomplex_dist.c
    zlangs_dist.c
    zgsequ_dist.c
    zlaqgs_dist.c
    zutil_dist.c
    zmemory_dist.c
    zmyblas2_dist.c
    zsp_blas2_dist.c
    zsp_blas3_dist.c
    pzgssvx.c
    pzgssvx_ABglobal.c
    zreadhb.c
    zreadrb.c
    zreadtriple.c
    zbinary_io.c	
    zreadMM.c
    pzgsequ.c
    pzlaqgs.c
    zldperm_dist.c
    pzlangs.c
    pzutil.c
    pzsymbfact_distdata.c
    zdistribute.c
    pzdistribute.c
    pzgstrf.c
    pzgstrf2.c
    pzgstrs.c
    pzgstrs1.c
    pzgstrs_lsum.c
    pzgstrs_Bglobal.c
    pzgsrfs.c
    pzgsmv.c
    pzgsrfs_ABXglobal.c
    pzgsmv_AXglobal.c
    pzGetDiagU.c
  )
endif()

add_library(superlu_dist ${sources} ${HEADERS})
set(targets superlu_dist)
if (BUILD_SHARED_LIBS AND BUILD_STATIC_LIBS)
  # build both shared and static libs
  add_library(superlu_dist-static STATIC ${sources} ${HEADERS})
  list(APPEND targets superlu_dist-static)
endif()

set(superlu_dist_libs ${MPI_C_LIBRARIES} ${BLAS_LIB} ${LAPACK_LIB}
    ${PARMETIS_LIB} ${COMBBLAS_LIB})

if (NOT MSVC)
  list(APPEND superlu_dist_libs m)
endif ()

foreach(target ${targets})
    target_link_libraries(${target} ${superlu_dist_libs})
    if (HAVE_COMBBLAS)
        set_target_properties(${target} PROPERTIES
                              OUTPUT_NAME superlu_dist
                              VERSION ${PROJECT_VERSION}
                              SOVERSION ${VERSION_MAJOR}
			      LINKER_LANGUAGE CXX
			      )
    else()
        set_target_properties(${target} PROPERTIES
                              OUTPUT_NAME superlu_dist
                              VERSION ${PROJECT_VERSION}
                              SOVERSION ${VERSION_MAJOR}
			      )
    endif()
endforeach(target)

target_compile_definitions(superlu_dist PRIVATE SUPERLU_DIST_EXPORTS)
if(MSVC AND BUILD_SHARED_LIBS)
  set_target_properties(superlu_dist PROPERTIES
                        WINDOWS_EXPORT_ALL_SYMBOLS ON
  )
endif()

# Define GNU standard installation directories
include(GNUInstallDirs)

install(TARGETS ${targets}
# DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
    LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
    ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
)
install(FILES ${headers}
# DESTINATION ${CMAKE_INSTALL_PREFIX}/include)
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== SRC/Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 	  pxerr_dist.o superlu_timer.o symbfact.o \
 	  psymbfact.o psymbfact_util.o get_perm_c_parmetis.o mc64ad_dist.o \
 	  static_schedule.o xerr_dist.o smach_dist.o dmach_dist.o \
-	  superlu_dist_version.o
+	  superlu_dist_version.o TreeInterface.o
 
 ifeq "${ACC}" "GPU"
 ALLAUX += cublas_utils.o
@@ -56,7 +56,7 @@
 #
 # Routines for double precision parallel SuperLU
 DPLUSRC = pdgssvx.o pdgssvx_ABglobal.o \
-	  dreadhb.o dreadrb.o dreadtriple.o dreadMM.o \
+	  dreadhb.o dreadrb.o dreadtriple.o dreadMM.o dbinary_io.o \
 	  pdgsequ.o pdlaqgs.o dldperm_dist.o pdlangs.o pdutil.o \
 	  pdsymbfact_distdata.o ddistribute.o pddistribute.o \
 	  pdgstrf.o pdgstrf2.o pdGetDiagU.o \
@@ -66,7 +66,7 @@
 #
 # Routines for double complex parallel SuperLU
 ZPLUSRC = pzgssvx.o pzgssvx_ABglobal.o \
-	  zreadhb.o zreadrb.o zreadtriple.o zreadMM.o \
+	  zreadhb.o zreadrb.o zreadtriple.o zreadMM.o zbinary_io.o\
 	  pzgsequ.o pzlaqgs.o zldperm_dist.o pzlangs.o pzutil.o \
 	  pzsymbfact_distdata.o zdistribute.o pzdistribute.o \
 	  pzgstrf.o pzgstrf2.o pzGetDiagU.o \
@@ -81,6 +81,11 @@
 		printf "#define XSDK_INDEX_SIZE 64\n" >> superlu_dist_config.h
 else
 		printf "/* #define XSDK_INDEX_SIZE 64 */\n" >> superlu_dist_config.h
+endif
+ifeq ($(HAVE_LAPACK),TRUE)
+		printf "#define HAVE_LAPACK TRUE\n" >> superlu_dist_config.h
+else
+		printf "/* #define HAVE_LAPACK TRUE */\n" >> superlu_dist_config.h
 endif
 ifeq ($(HAVE_PARMETIS),TRUE)
 		printf "#define HAVE_PARMETIS TRUE\n" >> superlu_dist_config.h
@@ -114,11 +119,11 @@
 pzgstrf.o: zscatter.c zlook_ahead_update.c zSchCompUdt-2Ddynamic.c pzgstrf.c
 	$(CC) $(CFLAGS) $(CDEFS) $(BLASDEF) -I$(INCLUDEDIR) -c pzgstrf.c $(VERBOSE)
 
-c2cpp_GetAWPM.o: c2cpp_GetAWPM.cpp
-	$(CXX) $(CXXFLAGS) -I$(INCLUDEDIR) -o $@ -c $<
-
 .c.o:
 	$(CC) $(CFLAGS) $(CDEFS) $(BLASDEF) -I$(INCLUDEDIR) -c $< $(VERBOSE)
+
+.cpp.o:
+	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(CDEFS) $(BLASDEF) -I$(INCLUDEDIR) -c $< $(VERBOSE)
 
 .f.o:
 	$(FORTRAN) $(FFLAGS) -c $< $(VERBOSE)

=== debian/changelog ===
superlu-dist (6.0.0+dfsg1-2) unstable; urgency=medium

  * disable ParMETIS support
    - true ParMETIS is not available (nonfree), but SCOTCH's emulation
      triggers a segfault in sp_colorder.c:163 since SCOTCH fails to
      update perm_c (permtab/peritab in
      library_graph_order.c:SCOTCH_graphOrderComputeList)

 -- Drew Parsons <dparsons@debian.org>  Sat, 20 Oct 2018 19:15:25 +0800

superlu-dist (6.0.0+dfsg1-1exp2) experimental; urgency=medium

  * merge default row permutations (NOROWPERM) and refresh
    only_short_tests.patch from 5.4.0+dfsg1-2..5.

 -- Drew Parsons <dparsons@debian.org>  Mon, 15 Oct 2018 13:58:42 +0800

superlu-dist (6.0.0+dfsg1-1exp1) experimental; urgency=medium

  * New upstream version
    - new ABI version 6
    - improved strong scaling of the triangular solve
    - now includes C++ code (build with mpic++)

 -- Drew Parsons <dparsons@debian.org>  Mon, 01 Oct 2018 13:01:38 +0800

superlu-dist (5.4.0+dfsg1-5) unstable; urgency=medium

  * propagate use of DEB_HOST_GNU_TYPE consistently throughout rules

 -- Drew Parsons <dparsons@debian.org>  Wed, 10 Oct 2018 02:01:14 +0800

superlu-dist (5.4.0+dfsg1-4) unstable; urgency=medium

  * build dir is DEB_HOST_GNU_TYPE not DEB_BUILD_MULTIARCH
    (see /usr/share/perl5/Debian/Debhelper/Buildsystem.pm)

 -- Drew Parsons <dparsons@debian.org>  Wed, 10 Oct 2018 00:03:03 +0800

superlu-dist (5.4.0+dfsg1-3) unstable; urgency=medium

  * use DEB_BUILD_MULTIARCH to determine build dir
  * set OMPI_MCA_rmaps_base_oversubscribe=1 to enable tests to run on
    smaller build systems

 -- Drew Parsons <dparsons@debian.org>  Tue, 09 Oct 2018 20:46:33 +0800

superlu-dist (5.4.0+dfsg1-2) unstable; urgency=medium

  * new Debian patches:
    - rowperm_default_NOROWPERM_not_MC64.patch: set default row
      permutation algorithm to NOROWPERM since MC64 is not available.
      MC64 has been removed since it uses code under a non-free HSL
      licence which does not permit redistribution. Document in
      README.Debian.
    - scotch_metis_v3.patch: use METIS v3 interface (non-NULL
      options). The METIS interface is handled by SCOTCH, which
      segfaults if NULL is sent to METIS_NodeND.
    - only_short_tests.patch: only run tests up to 2 rows or columns.
      Longer tests take 1000 sec or timeout, so drop them.
  * mark packages Multi-Arch: same
  * set MPIEXEC_PREFLAGS=--allow-run-as-root to allow build-time tests
    with fakeroot
  * run one built-time test at a time (tests themselves are MPI parallel,
    processors will get overloaded and tests will time out if multiple
    tests are run)
  * libsuperlu-dist-dev: install test files to
    /usr/lib/${DEB_HOST_MULTIARCH}/superlu-dist/tests
  * include debian/tests to run tests with autopkgtest

 -- Drew Parsons <dparsons@debian.org>  Mon, 08 Oct 2018 19:47:07 +0800

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,7 @@
 	cmake (>= 2.8.12),
 	mpi-default-dev, mpi-default-bin,
 	gfortran,
-	libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
-	libscotchparmetis-dev | libparmetis-dev,
-	libscotchmetis-dev | libmetis-dev
+	libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so
 Standards-Version: 4.2.1
 Section: libs
 Homepage: http://crd-legacy.lbl.gov/~xiaoye/SuperLU/#superlu_dist
@@ -18,7 +16,10 @@
 Package: libsuperlu-dist-dev
 Section: libdevel
 Architecture: any
-Depends: libsuperlu-dist5 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
+Depends: libsuperlu-dist6 (= ${binary:Version}),
+ ${shlibs:Depends},
+ ${misc:Depends}
 Description: Highly distributed solution of sparse linear equations
  SuperLU is a general purpose library for the direct solution of large,
  sparse, nonsymmetric systems of linear equations. The library is
@@ -48,8 +49,9 @@
  This package provides development files for building client 
  applications against superlu-dist.
 
-Package: libsuperlu-dist5
+Package: libsuperlu-dist6
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Highly distributed solution of sparse linear equations
  SuperLU is a general purpose library for the direct solution of large,

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 #export DH_VERBOSE = 1
 
 export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 # see FEATURE AREAS in dpkg-buildflags(1)
 #export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -16,7 +17,9 @@
 
 # Allow test programs that use OpenMPI to run
 export OMPI_MCA_plm_rsh_agent=/bin/false
+export OMPI_MCA_rmaps_base_oversubscribe=1
 
+export BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)
 
 %:
 	dh $@ --buildsystem=cmake
@@ -32,16 +35,25 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 	    -DBUILD_SHARED_LIBS=ON -DCMAKE_SKIP_RPATH=ON \
-	    -DCMAKE_C_COMPILER=mpicc -DCMAKE_FORTRAN_COMPILER=mpifort \
+	    -DCMAKE_C_COMPILER=mpicc \
+	    -DCMAKE_CXX_COMPILER=mpic++ \
+	    -DCMAKE_FORTRAN_COMPILER=mpifort \
+	    -DMPIEXEC_PREFLAGS=--allow-run-as-root \
 	    -DCMAKE_INSTALL_INCLUDEDIR=include/superlu-dist \
 	    -Denable_blaslib=OFF -DTPL_BLAS_LIBRARIES=/usr/lib/$(DEB_HOST_MULTIARCH)/libblas.so \
-	    -Denable_parmetislib=ON \
-	    -DTPL_PARMETIS_INCLUDE_DIRS="/usr/include/scotch;/usr/include/parmetis;/usr/include/metis" \
-	    -DTPL_PARMETIS_LIBRARIES="/usr/lib/$(DEB_HOST_MULTIARCH)/libparmetis.so;/usr/lib/$(DEB_HOST_MULTIARCH)/libmetis.so" \
+	    -DTPL_ENABLE_PARMETISLIB=OFF \
 	  || /bin/true
 
 
 # set LD_LIBRARY_PATH to test against the libsuperlu_dist.so just built
 override_dh_auto_test:
-	export LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/SRC:$${LD_LIBRARY_PATH}; \
-	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH} dh_auto_test || /bin/true
+	export LD_LIBRARY_PATH=$(CURDIR)/$(BUILDDIR)/SRC:$${LD_LIBRARY_PATH}; \
+	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH} dh_auto_test --max-parallel=1 || /bin/true
+
+override_dh_install:
+	dh_install
+	for testfile in $$( find debian/libsuperlu-dist-dev -name CTestTestfile.cmake ); do \
+	    sed -r "s|$(CURDIR)|<<builddir>>/superlu-dist|; \
+		    s|(.*)\".*/(EXAMPLE/.*ua)|\1\"/usr/lib/$(DEB_HOST_MULTIARCH)/superlu-dist/tests/\2|" \
+		-i $$testfile; \
+	done

## superlu-dist 6.1.0+dfsg1

=== debian/changelog ===
superlu-dist (6.1.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches and update build_with_combblas.patch to remove explicit
    flag -std=c++11 (std already updated to c++14 by CMAKE_CXX_STANDARD)

 -- Drew Parsons <dparsons@debian.org>  Tue, 11 Dec 2018 13:49:38 +0800

superlu-dist (6.0.0+dfsg1-3) unstable; urgency=medium

  * Build with CombBLAS support
    - Build-Depends: libcombblas-dev
    - debian patch build_with_combblas.patch:
      * applied C++14 standard (needed by CombBLAS)
      * indicate path to BipartiteMatchings header files
    - activate by setting RowPerm=LargeDiag_AWPM (square matrices only)

 -- Drew Parsons <dparsons@debian.org>  Sat, 24 Nov 2018 23:19:00 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
 	cmake (>= 2.8.12),
 	mpi-default-dev, mpi-default-bin,
 	gfortran,
-	libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so
+	libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
+	libcombblas-dev (>= 1.6.2-3)
 Standards-Version: 4.2.1
 Section: libs
 Homepage: http://crd-legacy.lbl.gov/~xiaoye/SuperLU/#superlu_dist

## superlu-dist 6.1.1%2Bdfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,8 +10,8 @@
 # Project version numbers
 project(SuperLU_DIST C CXX)
 set(VERSION_MAJOR "6")
-set(VERSION_MINOR "0")
-set(VERSION_BugFix "0")
+set(VERSION_MINOR "1")
+set(VERSION_BugFix "1")
 set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix})
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
@@ -49,6 +49,11 @@
 set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)    ## ????
 set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
 
+# set the position independent code property on all targets, so that
+# -fPIC is added in compiler flag.
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+
+
 #---- For shared library
 
 # use, i.e. don't skip the full RPATH for the build tree
@@ -118,6 +123,7 @@
 # Set up required compiler defines and options.
 ## get_directory_property( DirDefs COMPILE_DEFINITIONS )
 # set(CMAKE_C_FLAGS "-DDEBUGlevel=0 -DPRNTlevel=0 ${CMAKE_C_FLAGS}")
+set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
 if(XSDK_INDEX_SIZE EQUAL 64)
     message("-- Using 64 bit integer for index size.")
 endif()	
@@ -200,7 +206,7 @@
   endif()
 else()  ## not to use LAPACK
   set(LAPACK_FOUND FALSE)
-  set(HAVE_LAPACK FALSE)
+  set(SLU_HAVE_LAPACK FALSE)
 endif()
 
 if(LAPACK_FOUND)
@@ -209,7 +215,7 @@
     # fix up LAPACK library name
     string (REPLACE ";" " " LAPACK_LIB_STR "${LAPACK_LIB}")
     set(LAPACK_LIB_EXPORT ${LAPACK_LIB_STR})
-    set(HAVE_LAPACK TRUE)
+    set(SLU_HAVE_LAPACK TRUE)
 else()
     message("-- Will not link with LAPACK.")
 endif()
